#include <stdio.h>
#include <dlfcn.h>

int
main(int argc, char *argv[])
{
	void *dlh;
#if 1
	void (*p)();

	/*
	 * check that dlopen works
	 */
	if ((dlh = dlopen("bar/bar.so", RTLD_NOW)) == NULL) {
		fprintf(stderr, "dlopen: %s\n", dlerror());
		return 1;
	}

	if ((p = dlsym(dlh, "hello")) == NULL) {
		fprintf(stderr, "dlsym: %s\n", dlerror());
		return 1;
	}

	printf("hello(): %p\n", p);
	p();
	dlclose(dlh);

	/*
	 * check if we can dlopen self
	 */
	if ((dlh = dlopen(NULL, RTLD_NOW)) == NULL) {
		fprintf(stderr, "dlopen: %s\n", dlerror());
		return 1;
	}

	if ((p = dlsym(dlh, "main")) == NULL) {
		fprintf(stderr, "dlsym: %s\n", dlerror());
		return 1;
	}

	dlclose(dlh);
	printf("main(): %p\n", p);
	return 0;
#else
	int (*p)(const char *,...);

	if ((dlh = dlopen("libc.so", RTLD_NOW)) == NULL) {
		fprintf(stderr, "dlopen: %s\n", dlerror());
		return 1;
	}

	if ((p = dlsym(dlh, "printf")) == NULL) {
		fprintf(stderr, "dlsym: %s\n", dlerror());
		return 1;
	}

	printf("printf(): %p\n", p);
	p("Hello, world\n");
	dlclose(dlh);
#endif
}
